unit UEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Mask;

type
 TAlphabet=#0..#255;
 TAlphabetSet=set of TAlphabet;

 TEditInfo=record
  msg:string;
  mask:string;
  length:integer;
  replace:boolean;
  aset:TAlphabetSet;
 end;

type
  TFrmEdit = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Edit1: TMaskEdit;
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
   fres:string;
  public
    Status:string;
    Mask  :string;
    Length:integer;
    Replace:boolean;
    Alphabet:TAlphabetSet;
    property Result:string read fres;
  end;

var
  FrmEdit: TFrmEdit;

implementation

{$R *.dfm}
uses
 U8085;
procedure TFrmEdit.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

begin
 if key=VK_RETURN then
  begin
   fres:=Edit1.editText;
   ModalResult:=1;
  end
 else if key=VK_ESCAPE then
  begin
   fres:='';
   ModalResult:=1;
  end;
end;

procedure TFrmEdit.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 key:=UpCase(key);
 if not (key in Alphabet) then
  key:=#0
 else if replace then edit1.SelLength:=1;
end;

procedure TFrmEdit.FormShow(Sender: TObject);
begin
 frmedit.Caption:=Status;
 Label1.caption:=status+':';
 Edit1.MaxLength:=length;
 Edit1.EditMask:=Mask;
end;

procedure TFrmEdit.FormCreate(Sender: TObject);
begin
 Length:=0;fres:='';mask:='';replace:=false; 
end;

end.
